
/*  @(#)text2latex.c 1.3 95/07/07
 *
 *  Copyright (c) Mikael Cam.
 *                All rights reserved.
 *
 *  Permission is given to distribute these sources, as long as the
 *  copyright messages are not removed, and no monies are exchanged.
 *
 *  No responsibility is taken for any errors inherent either
 *  to the comments or the code of this program, but if reported
 *  to me then an attempt will be made to fix them.
 */

/* if the source document contains the string:  \end{verbatimtab} converts it
 * into \end{verbatimtab }, which is not correct but doesn't fail with
 * LaTeX...
 */

#define _TRACE  0
#define T( toto ) fprintf(stderr, "%s\n", toto)

#include <stdio.h>
#include <string.h>
#define  True   1
#define  False  0

char *usage = "Usage: text2latex [input_file] (else stdin)\n";

int convert(char *filename)
{

  char *ERR[] = {
                "Erreur lors de l'ouverture du fichier source\n"
	       };	  

  char *corresp[] = {
                     "\\end{verbatimtab}",        "\\end{verbatimtab }",
		     NULL,                 NULL 
		   };


  FILE *fp;
  char carcour;
  char buffer[256];
  int  buf_ind = 0;
  int i;
  int ind = 0;
  char Trouve;

  /* if (_TRACE) for ( i = 0; corresp[i]; i++) printf("%s\n", corresp[i]); */

  if(!strcmp(filename, "stdin")) fp = stdin;
  else
    if (!(fp = fopen(filename, "r"))) {
      fprintf(stderr, "%s", ERR[0]);
      exit(1);
    } 

  if (_TRACE) T("Fichier ouvert!");
  
  
  while ((fscanf (fp, "%c", &carcour)) != EOF) {
    
    if (buf_ind < 254) {
      *(buffer+buf_ind) = carcour;
      *(buffer+buf_ind+1) = '\0';
      buf_ind ++;
      if (_TRACE) fprintf(stderr, "buffer: %s\n", buffer);
    }
    
    
    else    {
      fprintf(stdout, "%s", buffer);
      buf_ind = 0;
      *buffer = carcour;
      *(buffer+1) = '\0';
    }
    
    
    Trouve = False;
    
    
    
    if (_TRACE) fprintf(stderr, "Indice: %d\n", ind);
    
    
    if (!strncmp(corresp[ind], buffer, strlen(buffer))) Trouve = True;
    else {
      ind = 0;
      
      while ((corresp[ind]) && (!Trouve))
	{
	  if (!strncmp(corresp[ind], buffer, strlen(buffer))) Trouve = True;
	  if (!Trouve) ind += 2;
	}
    }
    
    if (!Trouve) {
      fprintf(stdout, "%s", buffer);
      buf_ind = 0;
      ind = 0;
    }
    if ((Trouve) && (!strcmp(corresp[ind], buffer))) {
      fprintf(stdout, "%s", corresp[ind+1]);
      buf_ind = 0;
    }
    
    
    

                                                   }

}

int main(int argc, char *argv[])
{
  char fichier[50];
  switch (argc)
    {
    case 1: strcpy(fichier, "stdin"); break;
    case 2: strcpy(fichier, argv[1]); break;
    default: fprintf(stderr, "%s", usage); exit(1);
    }
  convert(fichier);
}








