
/*  @(#)print.h 1.6 95/02/10
 *
 *  Contains definitions for class "Print".
 *
 *  Copyright (c) Steve Holden and Rich Burridge.
 *                All rights reserved.
 *
 *  Permission is given to distribute these sources, as long as the
 *  copyright messages are not removed, and no monies are exchanged.
 *
 *  No responsibility is taken for any errors or inaccuracies inherent
 *  either to the comments or the code of this program, but if
 *  reported to me then an attempt will be made to fix them.
 */

#define  EQUALN(a, b) (*a == *b && !strncmp(a, b, strlen(b)))

#define  MAXTTYPES    4                 /* Maximum number of text types. */

enum action_type { IS_COL, IS_FILE, IS_LINE, IS_PAGE } ;
enum text_type   { T_BOLD, T_MIXED, T_PLAIN, T_ROMAN } ;

extern FILE *makecmd               (char *) ;

extern char *current_filename      (void) ;

extern void End                    (enum action_type) ;
extern void Print                  (void) ;
extern void print_extra            (void) ;
extern void set_column_count       (int) ;
extern void set_current_filename   (char *) ;
extern void set_line_count         (int) ;
extern void set_message_for        (char *) ;
extern void set_output             (FILE *) ;
extern void set_page_number        (int) ;
extern void show_prologue          (char *) ;
extern void show_text              (enum text_type, char *, char *) ;
extern void show_trailer           (void) ;
extern void Start                  (enum action_type) ;
extern void write_output           (char *) ;
